-- There is no copyright on this code

-- Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
-- associated documentation files (the "Software"), to deal in the Software without restriction, including
-- without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the Software is furnished to do so.

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
-- LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
-- NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
-- SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

--
-- Global variables
--

CancelBuffWarning = {}
CancelBuffWarning.name = "CancelBuffWarning"

--
-- Main functions
--

function CancelBuffWarning.Create(name, buff, target)
	local cancWarn = {}
	cancWarn.name = name
	cancWarn.buff = buff
	cancWarn.target = target
	
	return cancWarn
end

function CancelBuffWarning.Show(cancWarn)
	local buffID = nil
	local buffIDs = Inspect.Buff.List(cancWarn.target)
	if buffIDs then
		for id, detail in pairs(Inspect.Buff.Detail(cancWarn.target, buffIDs)) do
			if detail.name == cancWarn.buff or detail.description == cancWarn.buff then
				buffID = id
				break
			end
		end
	end
	
	if buffID then
		Command.Buff.Cancel(buffID)
	end
end

function CancelBuffWarning.Hide(cancWarn)
end

function CancelBuffWarning.SetVisible(cancWarn, visible)
	if visible == true then
		CancelBuffWarning.Show(cancWarn)
	else
		CancelBuffWarning.Hide(cancWarn)
	end
end

--
-- Event Handlers
--

--
-- Register events
--

