-- There is no copyright on this code

-- Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
-- associated documentation files (the "Software"), to deal in the Software without restriction, including
-- without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the Software is furnished to do so.

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
-- LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
-- NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
-- SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

--
-- Global variables
--

ConfirmationWindow = {}
ConfirmationWindow.name = "ConfirmationWindow"
ConfirmationWindow.version = "$Rev$"

--
-- Main functions
--

--
-- UI functions
--

function ConfirmationWindow.CreateConfirmationWindow(parentFrame, positonFrame)
	local cfmWindow = {}
	cfmWindow.confirmationWindow = UI.CreateFrame("RiftWindow", "cfmWindow", parentFrame)
	cfmWindow.confirmationWindow:SetVisible(false)
	cfmWindow.confirmationWindow:SetTitle("Confirmation window")
	cfmWindow.confirmationWindow:SetHeight(250)
	cfmWindow.confirmationWindow:SetPoint("CENTER", positonFrame, "CENTER")
	cfmWindow.confirmationWindow:SetLayer(5)
	
	cfmWindow.confirmationWindowYesButton = UI.CreateFrame("RiftButton", "ConfirmationYesButton", cfmWindow.confirmationWindow)
	cfmWindow.confirmationWindowYesButton:SetText("Yes")
	cfmWindow.confirmationWindowYesButton:SetPoint("BOTTOMLEFT", cfmWindow.confirmationWindow, "BOTTOMLEFT", 20, -20)
	cfmWindow.confirmationWindowYesButton.Event.LeftPress = function() ConfirmationWindow.ConfirmationWindowClose(cfmWindow, true) end
	
	cfmWindow.confirmationWindowNoButton = UI.CreateFrame("RiftButton", "ConfirmationNoButton", cfmWindow.confirmationWindow)
	cfmWindow.confirmationWindowNoButton:SetText("No")
	cfmWindow.confirmationWindowNoButton:SetPoint("BOTTOMRIGHT", cfmWindow.confirmationWindow, "BOTTOMRIGHT", -20, -20)
	cfmWindow.confirmationWindowNoButton.Event.LeftPress = function() ConfirmationWindow.ConfirmationWindowClose(cfmWindow, false) end
	
	cfmWindow.confirmationLabel = UI.CreateFrame("Text", "ConfirmationLabel", cfmWindow.confirmationWindow)
	cfmWindow.confirmationLabel:SetPoint("TOPLEFT", cfmWindow.confirmationWindow, "TOPLEFT", 20, 60)
	cfmWindow.confirmationLabel:SetPoint("BOTTOMRIGHT", cfmWindow.confirmationWindowNoButton, "TOPRIGHT", 0, -20)
	cfmWindow.confirmationLabel:SetWordwrap(true)
	cfmWindow.confirmationLabel:SetText("Dummy message")
	
	cfmWindow.confirmationWindow:SetWidth(cfmWindow.confirmationWindowYesButton:GetWidth() * 2 + 60)

	cfmWindow.confirmationCallback = nil
	return cfmWindow
end

function ConfirmationWindow.ShowConfirmationWindow(cfmWindow, message, callback)
	if message ~= nil then
		cfmWindow.confirmationLabel:SetText(message)
	end
	cfmWindow.confirmationCallback = callback
	cfmWindow.confirmationWindow:SetVisible(true)
end

function ConfirmationWindow.ConfirmationWindowClose(cfmWindow, okPressed)
	cfmWindow.confirmationWindow:SetVisible(false)
	if cfmWindow.confirmationCallback then
		cfmWindow.confirmationCallback(cfmWindow, okPressed)
	end
end
