-- Helper Functions

local function SetContent(widget, frame)
	widget.content = frame
	if widget.content then
		widget.content:SetPoint("TOPLEFT", widget.topleft, "BOTTOMRIGHT")
		widget.content:SetPoint("BOTTOMRIGHT", widget.bottomright, "TOPLEFT")
	end
end

local function GetContent(widget)
	if not widget.content then
		local frame = UI.CreateFrame("Mask", widget:GetName() .. "Content", widget)
		SetContent(widget, frame)
	end
	
	return widget.content
end

-- Constructor Function

function Library.LibSimpleWidgetsExt.Border(name, parent)
	local widget = UI.CreateFrame("Frame", name, parent)

	widget.topleft = UI.CreateFrame("Texture", widget:GetName().."TopLeft", widget)
	widget.topleft:SetTexture("LibSimpleWidgetsExt", "Textures/FrameTopLeft.png")
	widget.topleft:SetPoint("TOPLEFT", widget, "TOPLEFT")

	widget.topright = UI.CreateFrame("Texture", widget:GetName().."TopRight", widget)
	widget.topright:SetTexture("LibSimpleWidgetsExt", "Textures/FrameTopRight.png")
	widget.topright:SetPoint("TOPRIGHT", widget, "TOPRIGHT")

	widget.bottomright = UI.CreateFrame("Texture", widget:GetName().."BottomRight", widget)
	widget.bottomright:SetTexture("LibSimpleWidgetsExt", "Textures/FrameBottomRight.png")
	widget.bottomright:SetPoint("BOTTOMRIGHT", widget, "BOTTOMRIGHT")

	widget.bottomleft = UI.CreateFrame("Texture", widget:GetName().."BottomLeft", widget)
	widget.bottomleft:SetTexture("LibSimpleWidgetsExt", "Textures/FrameBottomLeft.png")
	widget.bottomleft:SetPoint("BOTTOMLEFT", widget, "BOTTOMLEFT")

	widget.top = UI.CreateFrame("Texture", widget:GetName().."Top", widget)
	widget.top:SetTexture("LibSimpleWidgetsExt", "Textures/FrameTop.png")
	widget.top:SetPoint("TOPLEFT", widget.topleft, "TOPRIGHT")
	widget.top:SetPoint("BOTTOMRIGHT", widget.topright, "BOTTOMLEFT")

	widget.left = UI.CreateFrame("Texture", widget:GetName().."Left", widget)
	widget.left:SetTexture("LibSimpleWidgetsExt", "Textures/FrameLeft.png")
	widget.left:SetPoint("TOPLEFT", widget.topleft, "BOTTOMLEFT")
	widget.left:SetPoint("BOTTOMRIGHT", widget.bottomleft, "TOPRIGHT")

	widget.right = UI.CreateFrame("Texture", widget:GetName().."Right", widget)
	widget.right:SetTexture("LibSimpleWidgetsExt", "Textures/FrameRight.png")
	widget.right:SetPoint("TOPLEFT", widget.topright, "BOTTOMLEFT")
	widget.right:SetPoint("BOTTOMRIGHT", widget.bottomright, "TOPRIGHT")

	widget.bottom = UI.CreateFrame("Texture", widget:GetName().."Bottom", widget)
	widget.bottom:SetTexture("LibSimpleWidgetsExt", "Textures/FrameBottom.png")
	widget.bottom:SetPoint("TOPLEFT", widget.bottomleft, "TOPRIGHT")
	widget.bottom:SetPoint("BOTTOMRIGHT", widget.bottomright, "BOTTOMLEFT")

	-- Public API
	widget.GetContent = GetContent
	widget.SetContent = SetContent

	return widget
end
