-- There is no copyright on this code

-- Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
-- associated documentation files (the "Software"), to deal in the Software without restriction, including
-- without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the Software is furnished to do so.

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
-- LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
-- NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
-- SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

--
-- Global variables
--

ScreenFlashWarningConfig = {}
ScreenFlashWarningConfig.name = "ScreenFlashWarningConfig"
ScreenFlashWarningConfig.version = "$Id$"

--
-- Main functions
--

--
-- UI functions
--

function ScreenFlashWarningConfig.Create(parentFrame, callback)
	local scrnFlashWarnConfig = {}
	scrnFlashWarnConfig.parentFrame = parentFrame
	scrnFlashWarnConfig.callback = callback
	scrnFlashWarnConfig.warning = ScreenFlashWarningConfig.GetDefaultWarning()
	
	scrnFlashWarnConfig.windowFrame = UI.CreateFrame("RiftWindow", "FlashWarningSelector", parentFrame)
	scrnFlashWarnConfig.windowFrame:SetTitle("Screen Flash Warning Editor")
	scrnFlashWarnConfig.windowFrame:SetWidth(700)
	scrnFlashWarnConfig.windowFrame:SetHeight(620)
	scrnFlashWarnConfig.windowFrame:SetPoint("CENTER", UIParent, "CENTER")

	scrnFlashWarnConfig.okButton = UI.CreateFrame("RiftButton", "OKButton", scrnFlashWarnConfig.windowFrame)
	scrnFlashWarnConfig.okButton:SetPoint("BOTTOMLEFT", scrnFlashWarnConfig.windowFrame, "BOTTOMLEFT", 20, -20)
	scrnFlashWarnConfig.okButton:SetText("OK")
	scrnFlashWarnConfig.okButton.Event.LeftPress = function() ScreenFlashWarningConfig.WindowClose(scrnFlashWarnConfig, true) end	

	scrnFlashWarnConfig.cancelButton = UI.CreateFrame("RiftButton", "CancelButton", scrnFlashWarnConfig.windowFrame)
	scrnFlashWarnConfig.cancelButton:SetPoint("BOTTOMRIGHT", scrnFlashWarnConfig.windowFrame, "BOTTOMRIGHT", -20, -20)
	scrnFlashWarnConfig.cancelButton:SetText("Cancel")
	scrnFlashWarnConfig.cancelButton.Event.LeftPress = function() ScreenFlashWarningConfig.WindowClose(scrnFlashWarnConfig, false) end	

	local margin = 4
	local height = 40
	scrnFlashWarnConfig.gridFrame = UI.CreateFrame("Frame", "GridFrame", scrnFlashWarnConfig.windowFrame)
	scrnFlashWarnConfig.gridFrame:SetPoint("TOPLEFT", scrnFlashWarnConfig.windowFrame, "TOPLEFT", 40, 80)
	scrnFlashWarnConfig.rowLayout = RowLayout.Create(scrnFlashWarnConfig.gridFrame, 8, 3, height, 200, margin, margin)

	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 1, 1, "Text")
	txtFrame:SetText("Name")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 1, 3, "Text")
	txtFrame:SetWordwrap(true)
	txtFrame:SetText("The name of the warning must be unique")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 2, 1, "Text")
	txtFrame:SetText("screen%")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 3, 1, "Text")
	txtFrame:SetText("Display duration (secs)")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 3, 3, "Text")
	txtFrame:SetWordwrap(true)
	txtFrame:SetText("Duration of 0 means show until event ends")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 4, 1, "Text")
	txtFrame:SetText("Alpha Level (0-1)")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 4, 3, "Text")
	txtFrame:SetWordwrap(true)
	txtFrame:SetText("Sets the transparency of the warning")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 5, 1, "Text")
	txtFrame:SetText("Screen colour")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 6, 1, "Text")
	txtFrame:SetText("Flash frequency (secs)")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 6, 3, "Text")
	txtFrame:SetWordwrap(true)
	txtFrame:SetText("How often the warning flashes, 0 means never")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 7, 1, "Text")
	txtFrame:SetText("Flash Alpha level")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 7, 3, "Text")
	txtFrame:SetWordwrap(true)
	txtFrame:SetText("Set the transparency of the flashed text")
	local txtFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 8, 1, "Text")
	txtFrame:SetText("Flash colour")

	scrnFlashWarnConfig.colourFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 5, 2, "Frame")
	scrnFlashWarnConfig.flashColourFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 8, 2, "Frame")

	
	scrnFlashWarnConfig.nameFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 1, 2, "RiftTextfield")
	scrnFlashWarnConfig.nameFrame:SetBackgroundColor(0.15, 0.15, 0.15)
	
	scrnFlashWarnConfig.screenPctSlider = ScreenFlashWarningConfig.CreateSlider(scrnFlashWarnConfig, 2, 2, 0, 100, 1)
	scrnFlashWarnConfig.durationSlider = ScreenFlashWarningConfig.CreateSlider(scrnFlashWarnConfig, 3, 2, 0, 300, 1)
	scrnFlashWarnConfig.alphaSlider = ScreenFlashWarningConfig.CreateSlider(scrnFlashWarnConfig, 4, 2, 0, 1, 0.05)
	scrnFlashWarnConfig.flashDurationSlider = ScreenFlashWarningConfig.CreateSlider(scrnFlashWarnConfig, 6, 2, 0, 30, 1)
	scrnFlashWarnConfig.flashAlphaSlider = ScreenFlashWarningConfig.CreateSlider(scrnFlashWarnConfig, 7, 2, 0, 1, 0.05)
	
	scrnFlashWarnConfig.colourButton = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 5, 3, "RiftButton", RowLayout.centerFrame)
	scrnFlashWarnConfig.colourButton:SetText("Choose")
	scrnFlashWarnConfig.colourButton.Event.LeftPress = function() ScreenFlashWarningConfig.ShowChooseColour(scrnFlashWarnConfig) end
	scrnFlashWarnConfig.flashColourButton = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, 8, 3, "RiftButton", RowLayout.centerFrame)
	scrnFlashWarnConfig.flashColourButton:SetText("Choose")
	scrnFlashWarnConfig.flashColourButton.Event.LeftPress = function() ScreenFlashWarningConfig.ShowChooseFlashColour(scrnFlashWarnConfig) end
	RowLayout.SetColWidth(scrnFlashWarnConfig.rowLayout, 3, scrnFlashWarnConfig.flashColourButton:GetWidth())

	RowLayout.Redraw(scrnFlashWarnConfig.rowLayout)

	scrnFlashWarnConfig.clrChooser = ColourChooser.Create(scrnFlashWarnConfig.windowFrame, scrnFlashWarnConfig.warning.colour)
	scrnFlashWarnConfig.wrnWindow = WarningWindow.CreateWarningWindow(scrnFlashWarnConfig.parentFrame, scrnFlashWarnConfig.windowFrame)
	
	ScreenFlashWarningConfig.Show(scrnFlashWarnConfig)
	scrnFlashWarnConfig.windowFrame:SetVisible(false)
	
	return scrnFlashWarnConfig
end

function ScreenFlashWarningConfig.WindowClose(scrnFlashWarnConfig, okPressed)
	if okPressed == true then
		local message = ""
		local name = scrnFlashWarnConfig.nameFrame:GetText()
		if not name or string.len(name) < 1 then
			message = message .. "You must specify a name for this warning\n"
		end
		
		if string.len(message) > 0 then
			ScreenFlashWarningConfig.SetEnabled(scrnFlashWarnConfig, false)
			WarningWindow.ShowWarningWindow(scrnFlashWarnConfig.wrnWindow, message, function() ScreenFlashWarningConfig.SetEnabled(scrnFlashWarnConfig, true) end)
			return
		end
		
		ScreenFlashWarningConfig.FillWarning(scrnFlashWarnConfig)
	end
	
	scrnFlashWarnConfig.nameFrame:SetKeyFocus(false)
	
	scrnFlashWarnConfig.windowFrame:SetVisible(false)
	if scrnFlashWarnConfig.callback then
		if okPressed == true then
			scrnFlashWarnConfig.callback(scrnFlashWarnConfig, scrnFlashWarnConfig.warning)
		else
			scrnFlashWarnConfig.callback(scrnFlashWarnConfig)
		end
	end
end

function ScreenFlashWarningConfig.Show(scrnFlashWarnConfig, inWarning)
	if inWarning then
		scrnFlashWarnConfig.warning = ScreenFlashWarningConfig.CopyWarning(inWarning)
	end
	
	local warning = scrnFlashWarnConfig.warning
	scrnFlashWarnConfig.colourFrame:SetBackgroundColor(warning.colour.red, warning.colour.green, warning.colour.blue)
	scrnFlashWarnConfig.flashColourFrame:SetBackgroundColor(warning.flashColour.red, warning.flashColour.green, warning.flashColour.blue)
	scrnFlashWarnConfig.nameFrame:SetText(warning.name)
	NumberSlider.SetValue(scrnFlashWarnConfig.screenPctSlider, warning.screenPct)
	NumberSlider.SetValue(scrnFlashWarnConfig.durationSlider, warning.duration)
	NumberSlider.SetValue(scrnFlashWarnConfig.alphaSlider, warning.alpha)
	NumberSlider.SetValue(scrnFlashWarnConfig.flashDurationSlider, warning.flashFrequency)
	NumberSlider.SetValue(scrnFlashWarnConfig.flashAlphaSlider, warning.flashAlpha)
	scrnFlashWarnConfig.windowFrame:SetVisible(true)
end

function ScreenFlashWarningConfig.FillWarning(scrnFlashWarnConfig)
	scrnFlashWarnConfig.warning.name = scrnFlashWarnConfig.nameFrame:GetText()
	scrnFlashWarnConfig.warning.screenPct = NumberSlider.GetValue(scrnFlashWarnConfig.screenPctSlider)
	scrnFlashWarnConfig.warning.duration = NumberSlider.GetValue(scrnFlashWarnConfig.durationSlider)
	scrnFlashWarnConfig.warning.alpha = NumberSlider.GetValue(scrnFlashWarnConfig.alphaSlider)
	scrnFlashWarnConfig.warning.flashFrequency = NumberSlider.GetValue(scrnFlashWarnConfig.flashDurationSlider)
	scrnFlashWarnConfig.warning.flashAlpha = NumberSlider.GetValue(scrnFlashWarnConfig.flashAlphaSlider)
end

function ScreenFlashWarningConfig.SetEnabled(scrnFlashWarnConfig, enabled)
	scrnFlashWarnConfig.okButton:SetEnabled(enabled)
	scrnFlashWarnConfig.cancelButton:SetEnabled(enabled)
	scrnFlashWarnConfig.colourButton:SetEnabled(enabled)
	scrnFlashWarnConfig.flashColourButton:SetEnabled(enabled)
	NumberSlider.SetEnabled(scrnFlashWarnConfig.screenPctSlider, enabled)
	NumberSlider.SetEnabled(scrnFlashWarnConfig.durationSlider, enabled)
	NumberSlider.SetEnabled(scrnFlashWarnConfig.alphaSlider, enabled)
	NumberSlider.SetEnabled(scrnFlashWarnConfig.flashDurationSlider, enabled)
	NumberSlider.SetEnabled(scrnFlashWarnConfig.flashAlphaSlider, enabled)
end

function ScreenFlashWarningConfig.CreateSlider(scrnFlashWarnConfig, row, col, minValue, maxValue, stepSize)
	local xyFrame = RowLayout.CreateFrame(scrnFlashWarnConfig.rowLayout, row, col, "Frame")
	return NumberSlider.Create(xyFrame, minValue, maxValue, stepSize, minValue)
end

function ScreenFlashWarningConfig.ShowChooseColour(scrnFlashWarnConfig)
	ScreenFlashWarningConfig.SetEnabled(scrnFlashWarnConfig, false)
	ColourChooser.Show(scrnFlashWarnConfig.clrChooser, scrnFlashWarnConfig.warning.colour, function(x, colour) ScreenFlashWarningConfig.ChooseColour(scrnFlashWarnConfig, colour) end)
end

function ScreenFlashWarningConfig.ChooseColour(scrnFlashWarnConfig, colour)
	ScreenFlashWarningConfig.SetEnabled(scrnFlashWarnConfig, true)
	if colour then
		scrnFlashWarnConfig.warning.colour = colour
		ScreenFlashWarningConfig.FillWarning(scrnFlashWarnConfig)
		ScreenFlashWarningConfig.Show(scrnFlashWarnConfig)
	end
end

function ScreenFlashWarningConfig.ShowChooseFlashColour(scrnFlashWarnConfig)
	ScreenFlashWarningConfig.SetEnabled(scrnFlashWarnConfig, false)
	ColourChooser.Show(scrnFlashWarnConfig.clrChooser, scrnFlashWarnConfig.warning.flashColour, function(x, colour) ScreenFlashWarningConfig.ChooseFlashColour(scrnFlashWarnConfig, colour) end)
end

function ScreenFlashWarningConfig.ChooseFlashColour(scrnFlashWarnConfig, colour)
	ScreenFlashWarningConfig.SetEnabled(scrnFlashWarnConfig, true)
	if colour then
		scrnFlashWarnConfig.warning.flashColour = colour
		ScreenFlashWarningConfig.FillWarning(scrnFlashWarnConfig)
		ScreenFlashWarningConfig.Show(scrnFlashWarnConfig)
	end
end

function ScreenFlashWarningConfig.CopyWarning(warning2)
	local warning = {}
	warning.warningType = WarnMe.warningTypeScreenFlash
	warning.name = warning2.name
	warning.screenPct = warning2.screenPct
	warning.duration = warning2.duration
	warning.alpha = warning2.alpha
	warning.colour = {}
	warning.colour.red = warning2.colour.red
	warning.colour.green = warning2.colour.green
	warning.colour.blue = warning2.colour.blue
	warning.flashFrequency = warning2.flashFrequency
	warning.flashAlpha = warning2.flashAlpha
	warning.flashColour = {}
	warning.flashColour.red = warning2.flashColour.red
	warning.flashColour.green = warning2.flashColour.green
	warning.flashColour.blue = warning2.flashColour.blue
	
	return warning
end

function ScreenFlashWarningConfig.GetDefaultWarning()
	local warning = {}
	warning.warningType = WarnMe.warningTypeScreenFlash
	warning.name = ""
	warning.screenPct = 100
	warning.duration = 1
	warning.alpha = 1
	warning.colour = {}
	warning.colour.red = 1
	warning.colour.green = 1
	warning.colour.blue = 1
	warning.flashFrequency = 0
	warning.flashAlpha = 0.2
	warning.flashColour = {}
	warning.flashColour.red = 1
	warning.flashColour.green = 0
	warning.flashColour.blue = 0
	
	return warning
end

