-- There is no copyright on this code

-- Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
-- associated documentation files (the "Software"), to deal in the Software without restriction, including
-- without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the Software is furnished to do so.

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
-- LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
-- NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
-- SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

--
-- Global variables
--

WarnMeConfig = {}
WarnMeConfig.name = "WarnMeConfig"
WarnMeConfig.version = "$Id$"

--
-- Main functions
--

--
-- UI functions
--

function WarnMeConfig.Create(parentFrame, callback)
	local wmeConfig = {}
	wmeConfig.parentFrame = parentFrame
	wmeConfig.callback = callback
	
	wmeConfig.windowFrame = UI.CreateFrame("RiftWindow", "WarnMeConfig", parentFrame)
	wmeConfig.windowFrame:SetTitle("WarnMe Configuration")
	wmeConfig.windowFrame:SetWidth(780)
	wmeConfig.windowFrame:SetHeight(800)
	wmeConfig.windowFrame:SetPoint("CENTER", UIParent, "CENTER")

	wmeConfig.okButton = UI.CreateFrame("RiftButton", "OKButton", wmeConfig.windowFrame)
	wmeConfig.okButton:SetPoint("BOTTOMLEFT", wmeConfig.windowFrame, "BOTTOMLEFT", 10 + math.floor((wmeConfig.windowFrame:GetWidth() - wmeConfig.okButton:GetWidth()) / 2), -20)
	wmeConfig.okButton:SetText("OK")
	wmeConfig.okButton.Event.LeftPress = function() WarnMeConfig.WindowClose(wmeConfig) end	

	wmeConfig.infoFrame = UI.CreateFrame("Text", "InfoWindow", wmeConfig.windowFrame)
	wmeConfig.infoFrame:SetPoint("TOPLEFT", wmeConfig.windowFrame, "TOPLEFT", 40, 80)
	wmeConfig.infoFrame:SetPoint("TOPRIGHT", wmeConfig.windowFrame, "TOPRIGHT", -40, 80)
	wmeConfig.infoFrame:SetBackgroundColor(0.15, 0.15, 0.15, 0.5)
	wmeConfig.infoFrame:SetHeight(60)
	wmeConfig.infoFrame:SetWordwrap(true)

	local margin = 4
	local height = 40
	wmeConfig.gridFrame = UI.CreateFrame("Frame", "GridFrame", wmeConfig.windowFrame)
	wmeConfig.gridFrame:SetPoint("TOPLEFT", wmeConfig.infoFrame, "BOTTOMLEFT", 0, 20)
	wmeConfig.gridFrame:SetPoint("TOPRIGHT", wmeConfig.infoFrame, "BOTTOMRIGHT", 0, 20)
	wmeConfig.rowLayout = RowLayout.Create(wmeConfig.gridFrame, 13, 5, height, 140, margin, margin)

	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 1, 1, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Warnings")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 1, 2, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Text")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 2, 2, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Texture")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 3, 2, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Timer")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 4, 2, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Screen Flash")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 7, 1, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Events")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 7, 2, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Buff")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 8, 2, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Emote")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 9, 2, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Npc Chat")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 10, 2, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Castbar")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 11, 2, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Stat")
	local txtFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 12, 2, "Text")
	txtFrame:SetFontSize(24)
	txtFrame:SetText("Ability")

	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 5, 2, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Move")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.MoveWarnings(wmeConfig, WarnMe.totalWarnings) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 5, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Custom")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseCustomWarnings(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 13, 2, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Import")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ShowImportWindow(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 13, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Export")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ExportEvents(wmeConfig, WarnMe.totalEvents, WarnMe.totalWarnings) end
	
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 1, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Add")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.AddTextWarning(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 1, 4, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Edit")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseWarning(wmeConfig, WarnMe.warningTypeText, function(a, warningName) WarnMeConfig.EditTextWarning(wmeConfig, warningName) end) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 1, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Delete")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseWarning(wmeConfig, WarnMe.warningTypeText, function(a, warningName) WarnMeConfig.DeleteWarningCallback(wmeConfig, warningName) end) end

	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 2, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Add")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.AddTextureWarning(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 2, 4, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Edit")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseWarning(wmeConfig, WarnMe.warningTypeTexture, function(a, warningName) WarnMeConfig.EditTextureWarning(wmeConfig, warningName) end) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 2, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Delete")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseWarning(wmeConfig, WarnMe.warningTypeTexture, function(a, warningName) WarnMeConfig.DeleteWarningCallback(wmeConfig, warningName) end) end

	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 3, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Add")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.AddTimerWarning(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 3, 4, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Edit")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseWarning(wmeConfig, WarnMe.warningTypeTimer, function(a, warningName) WarnMeConfig.EditTimerWarning(wmeConfig, warningName) end) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 3, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Delete")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseWarning(wmeConfig, WarnMe.warningTypeTimer, function(a, warningName) WarnMeConfig.DeleteWarningCallback(wmeConfig, warningName) end) end

	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 4, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Add")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.AddScreenFlashWarning(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 4, 4, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Edit")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseWarning(wmeConfig, WarnMe.warningTypeScreenFlash, function(a, warningName) WarnMeConfig.EditScreenFlashWarning(wmeConfig, warningName) end) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 4, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Delete")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseWarning(wmeConfig, WarnMe.warningTypeScreenFlash, function(a, warningName) WarnMeConfig.DeleteWarningCallback(wmeConfig, warningName) end) end

	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 7, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Add")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.AddBuffEvent(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 7, 4, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Edit")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseBuffEvent(wmeConfig, function(a, eventName) WarnMeConfig.EditBuffEvent(wmeConfig, eventName) end) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 7, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Delete")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseBuffEvent(wmeConfig, function(a, eventName) WarnMeConfig.DeleteEventCallback(wmeConfig, eventName) end) end

	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 8, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Add")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.AddEmoteEvent(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 8, 4, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Edit")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseEvent(wmeConfig, WarnMe.eventTypeEmote, function(a, eventName) WarnMeConfig.EditEmoteEvent(wmeConfig, eventName) end) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 8, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Delete")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseEvent(wmeConfig, WarnMe.eventTypeEmote, function(a, eventName) WarnMeConfig.DeleteEventCallback(wmeConfig, eventName) end) end

	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 9, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Add")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.AddNpcChatEvent(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 9, 4, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Edit")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseEvent(wmeConfig, WarnMe.eventTypeNpcChat, function(a, eventName) WarnMeConfig.EditNpcChatEvent(wmeConfig, eventName) end) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 9, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Delete")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseEvent(wmeConfig, WarnMe.eventTypeNpcChat, function(a, eventName) WarnMeConfig.DeleteEventCallback(wmeConfig, eventName) end) end

	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 10, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Add")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.AddCastbarEvent(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 10, 4, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Edit")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseEvent(wmeConfig, WarnMe.eventTypeCastbar, function(a, eventName) WarnMeConfig.EditCastbarEvent(wmeConfig, eventName) end) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 10, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Delete")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseEvent(wmeConfig, WarnMe.eventTypeCastbar, function(a, eventName) WarnMeConfig.DeleteEventCallback(wmeConfig, eventName) end) end

	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 11, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Add")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.AddStatEvent(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 11, 4, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Edit")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseEvent(wmeConfig, WarnMe.eventTypeStat, function(a, eventName) WarnMeConfig.EditStatEvent(wmeConfig, eventName) end) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 11, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Delete")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseEvent(wmeConfig, WarnMe.eventTypeStat, function(a, eventName) WarnMeConfig.DeleteEventCallback(wmeConfig, eventName) end) end

	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 12, 3, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Add")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.AddAbilityEvent(wmeConfig) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 12, 4, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Edit")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseEvent(wmeConfig, WarnMe.eventTypeAbility, function(a, eventName) WarnMeConfig.EditAbilityEvent(wmeConfig, eventName) end) end
	local buttonFrame = RowLayout.CreateFrame(wmeConfig.rowLayout, 12, 5, "RiftButton", RowLayout.centerFrame)
	buttonFrame:SetText("Delete")
	buttonFrame.Event.LeftPress = function() WarnMeConfig.ChooseEvent(wmeConfig, WarnMe.eventTypeAbility, function(a, eventName) WarnMeConfig.DeleteEventCallback(wmeConfig, eventName) end) end

	RowLayout.SetColWidth(wmeConfig.rowLayout, 3, buttonFrame:GetWidth())
	RowLayout.SetColWidth(wmeConfig.rowLayout, 4, buttonFrame:GetWidth())
	RowLayout.SetColWidth(wmeConfig.rowLayout, 5, buttonFrame:GetWidth())

	RowLayout.Redraw(wmeConfig.rowLayout)

	wmeConfig.wrnWindow = WarningWindow.CreateWarningWindow(wmeConfig.parentFrame, wmeConfig.windowFrame)
	wmeConfig.cfmWindow = ConfirmationWindow.CreateConfirmationWindow(wmeConfig.parentFrame, wmeConfig.windowFrame)
	wmeConfig.txtPicker = TextPicker.Create(wmeConfig.parentFrame)
	wmeConfig.txtWarning = TextWarningConfig.Create(wmeConfig.parentFrame, function(a, warning) WarnMeConfig.SetWarningCallback(wmeConfig, warning) end)
	wmeConfig.txtrWarning = TextureWarningConfig.Create(wmeConfig.parentFrame, function(a, warning) WarnMeConfig.SetWarningCallback(wmeConfig, warning) end)
	wmeConfig.timerWarning = TimerWarningConfig.Create(wmeConfig, wmeConfig.parentFrame, function(a, warning) WarnMeConfig.SetWarningCallback(wmeConfig, warning) end)
	wmeConfig.scrnFlashWarning = ScreenFlashWarningConfig.Create(wmeConfig.parentFrame, function(a, warning) WarnMeConfig.SetWarningCallback(wmeConfig, warning) end)
	wmeConfig.evtEmoteConfig = EmoteEventConfig.Create(wmeConfig, wmeConfig.parentFrame, function(a, event) WarnMeConfig.SetEventCallback(wmeConfig, event) end)
	wmeConfig.evtNpcChatConfig = NpcChatEventConfig.Create(wmeConfig, wmeConfig.parentFrame, function(a, event) WarnMeConfig.SetEventCallback(wmeConfig, event) end)
	wmeConfig.evtBuffConfig = BuffEventConfig.Create(wmeConfig, wmeConfig.parentFrame, function(a, event) WarnMeConfig.SetEventCallback(wmeConfig, event) end)
	wmeConfig.evtCastbarConfig = CastbarEventConfig.Create(wmeConfig, wmeConfig.parentFrame, function(a, event) WarnMeConfig.SetEventCallback(wmeConfig, event) end)
	wmeConfig.evtStatConfig = StatEventConfig.Create(wmeConfig, wmeConfig.parentFrame, function(a, event) WarnMeConfig.SetEventCallback(wmeConfig, event) end)
	wmeConfig.evtAbilityConfig = AbilityEventConfig.Create(wmeConfig, wmeConfig.parentFrame, function(a, event) WarnMeConfig.SetEventCallback(wmeConfig, event) end)
	wmeConfig.custWarnConfig = CustomWarningConfig.Create(wmeConfig.parentFrame, function() wmeConfig.windowFrame:SetVisible(true) end)

	WarnMeConfig.CreateExportWindow(wmeConfig)
	WarnMeConfig.CreateImportWindow(wmeConfig)

	WarnMeConfig.Show(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	
	return wmeConfig
end

function WarnMeConfig.WindowClose(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	if wmeConfig.callback then
		wmeConfig.callback(wmeConfig)
	end
end

function WarnMeConfig.GetVisible(wmeConfig)
	return wmeConfig.windowFrame:GetVisible()
end

function WarnMeConfig.SetVisible(wmeConfig, visible)
	if visible == true then
		WarnMeConfig.Show(wmeConfig)
	else
		WarnMeConfig.WindowClose(wmeConfig)
	end
end

function WarnMeConfig.Show(wmeConfig)
	local desc = "Current Role = "
	if WarnMe.currentRole == "0" then
		desc = desc .. "unset"
	else
		desc = desc .. WarnMe.currentRole
	end

	desc = desc .. ", Current Zone = "
	if WarnMe.currentZone == "" then
		desc = desc .. "unset\n"
	else
		desc = desc .. WarnMe.currentZone .. "\n"
	end
	
	if WarnMe.inParty == true then
		desc = desc .. "Player is in a party\n"
	end
	if WarnMe.inRaid == true then
		desc = desc .. "Player is in a raid\n"
	end
	if WarnMe.inCrossShardRaid == true then
		desc = desc .. "Player is in a cross shard raid\n"
	end
	if WarnMe.inCombat == true then
		desc = desc .. "Player is in combat\n"
	end
	
	wmeConfig.infoFrame:SetText(desc)
	wmeConfig.windowFrame:SetVisible(true)
end

function WarnMeConfig.ImportEvents(wmeConfig, events, warnings, overwrite)
	WarnMe.UpdateEvents(events)
	
	for name, warning in pairs(warnings) do
		if WarnMe.totalWarnings[name] then
			if overwrite == true then
				print("Overwritten warning " .. name)
				WarnMe.totalWarnings[name] = warning
			end
		else
			print("Imported warning " .. name)
			WarnMe.totalWarnings[name] = warning
		end
	end

	for name, event in pairs(events) do
		if WarnMe.totalEvents[name] then
			if overwrite == true then
				print("Overwritten event " .. name)
				WarnMe.totalEvents[name] = event
			end
		else
			print("Imported warning " .. name)
			WarnMe.totalEvents[name] = event
		end
	end
	
	wmeConfig.windowFrame:SetVisible(true)
end

function WarnMeConfig.ImportWindowClose(wmeConfig)
	wmeConfig.importText:SetKeyFocus(false)
	wmeConfig.importWindow:SetVisible(false)

	local inputString = Utilities.Trim(wmeConfig.importText:GetText())
	if not inputString or string.len(inputString) < 1 then
		WarningWindow.ShowWarningWindow(wmeConfig.wrnWindow, "Import is empty", function() wmeConfig.windowFrame:SetVisible(true) end)
		return
	end

	local importdataFn = loadstring("return " .. inputString)
	if not importdataFn then
		WarningWindow.ShowWarningWindow(wmeConfig.wrnWindow, "Import badly formatted", function() wmeConfig.windowFrame:SetVisible(true) end)
		return
	end
	
	local importdata = importdataFn()
	
	local hasEvents = false
	local hasDuplicateEvents = false
	local eventString = "Events: "
	if importdata.events then
		for name, event in pairs(importdata.events) do
			hasEvents = true
			if WarnMe.totalEvents[name] then
				if hasDuplicateEvents == true then
					eventString = eventString .. ", "
				end
				
				eventString = eventString .. name
				hasDuplicateEvents = true
			end
		end
	end
	
	local hasWarnings = false
	local hasDuplicateWarnings = false
	local warningString = "Warnings: "
	if importdata.warnings then
		for name, warning in pairs(importdata.warnings) do
			hasWarnings = true
			if WarnMe.totalWarnings[name] then
				if hasDuplicateWarnings == true then
					warningString = warningString .. ", "
				end
				
				warningString = warningString .. name
				hasDuplicateWarnings = true
			end
		end
	end
	
	if hasEvents == false then
		WarningWindow.ShowWarningWindow(wmeConfig.wrnWindow, "Import does not contain any events", function() wmeConfig.windowFrame:SetVisible(true) end)
		return
	end
	if hasWarnings == false then
		WarningWindow.ShowWarningWindow(wmeConfig.wrnWindow, "Import does not contain any warnings", function() wmeConfig.windowFrame:SetVisible(true) end)
		return
	end
	
	if hasDuplicateEvents == true or hasDuplicateWarnings == true then
		ConfirmationWindow.ShowConfirmationWindow(wmeConfig.cfmWindow, "Overwrite the following?:\n" .. eventString .. "\n" .. warningString, function(a, overwrite) WarnMeConfig.ImportEvents(wmeConfig, importdata.events, importdata.warnings, overwrite) end)
	else
		WarnMeConfig.ImportEvents(wmeConfig, importdata.events, importdata.warnings, false)
	end
end

function WarnMeConfig.CreateImportWindow(wmeConfig)
	-- Create import window
	wmeConfig.importWindow = UI.CreateFrame("RiftWindow", "ImportFrame", wmeConfig.parentFrame)
	wmeConfig.importWindow:SetVisible(false)
	wmeConfig.importWindow:SetWidth(200)
	wmeConfig.importWindow:SetHeight(150)
	wmeConfig.importWindow:SetPoint("CENTER", wmeConfig.parentFrame, "CENTER")
	wmeConfig.importWindow:SetTitle("Import events window")
	wmeConfig.importWindow:SetLayer(5)
	
	wmeConfig.importText = UI.CreateFrame("RiftTextfield", "ImportText", wmeConfig.importWindow)
	wmeConfig.importText:SetPoint("TOPLEFT", wmeConfig.importWindow, "TOPLEFT", 20, 60)
	wmeConfig.importText:SetPoint("TOPRIGHT", wmeConfig.importWindow, "TOPRIGHT", -20, 60)
	
	wmeConfig.importLabel = UI.CreateFrame("Text", "ImportLabel", wmeConfig.importWindow)
	wmeConfig.importLabel:SetPoint("TOPLEFT", wmeConfig.importWindow, "TOPLEFT", 20, 90)
	wmeConfig.importLabel:SetPoint("TOPRIGHT", wmeConfig.importWindow, "TOPRIGHT", -20, 90)
	wmeConfig.importLabel:SetText("Paste settings into the text box to import")
	
	wmeConfig.importWindowButton = UI.CreateFrame("RiftButton", "ImportButton", wmeConfig.importWindow)
	wmeConfig.importWindowButton:SetText("OK")
	wmeConfig.importWindowButton:SetPoint("TOPLEFT", wmeConfig.importWindow, "BOTTOMLEFT", 40, -35)
	wmeConfig.importWindowButton.Event.LeftPress = function() WarnMeConfig.ImportWindowClose(wmeConfig) end
end

function WarnMeConfig.ShowImportWindow(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	wmeConfig.importWindow:SetVisible(true)
	wmeConfig.importText:SetText("")
	wmeConfig.importText:SetKeyFocus(true)
end

function WarnMeConfig.ExportWindowClose(wmeConfig)
	wmeConfig.exportText:SetText("")
	wmeConfig.exportText:SetKeyFocus(false)
	wmeConfig.exportWindow:SetVisible(false)
	wmeConfig.windowFrame:SetVisible(true)
end

function WarnMeConfig.CreateExportWindow(wmeConfig)
	-- Create export window
	wmeConfig.exportWindow = UI.CreateFrame("RiftWindow", "ExportFrame", wmeConfig.parentFrame)
	wmeConfig.exportWindow:SetVisible(false)
	wmeConfig.exportWindow:SetWidth(200)
	wmeConfig.exportWindow:SetHeight(150)
	wmeConfig.exportWindow:SetPoint("CENTER", wmeConfig.parentFrame, "CENTER")
	wmeConfig.exportWindow:SetTitle("Export events window")
	wmeConfig.exportWindow:SetLayer(5)
	
	wmeConfig.exportText = UI.CreateFrame("RiftTextfield", "ExportText", wmeConfig.exportWindow)
	wmeConfig.exportText:SetPoint("TOPLEFT", wmeConfig.exportWindow, "TOPLEFT", 20, 60)
	wmeConfig.exportText:SetPoint("TOPRIGHT", wmeConfig.exportWindow, "TOPRIGHT", -20, 60)
	
	wmeConfig.exportLabel = UI.CreateFrame("Text", "ExportLabel", wmeConfig.exportWindow)
	wmeConfig.exportLabel:SetPoint("TOPLEFT", wmeConfig.exportWindow, "TOPLEFT", 20, 90)
	wmeConfig.exportLabel:SetPoint("TOPRIGHT", wmeConfig.exportWindow, "TOPRIGHT", -20, 90)
	wmeConfig.exportLabel:SetText("Press Ctrl+C to copy event data")
	
	wmeConfig.exportWindowButton = UI.CreateFrame("RiftButton", "ExportButton", wmeConfig.exportWindow)
	wmeConfig.exportWindowButton:SetText("OK")
	wmeConfig.exportWindowButton:SetPoint("TOPLEFT", wmeConfig.exportWindow, "BOTTOMLEFT", 40, -35)
	wmeConfig.exportWindowButton.Event.LeftPress = function() WarnMeConfig.ExportWindowClose(wmeConfig) end
end

function WarnMeConfig.ShowExportWindow(wmeConfig, textString)
	wmeConfig.exportWindow:SetVisible(true)
	wmeConfig.exportText:SetText(textString)
	wmeConfig.exportText:SetKeyFocus(true)
	local length = textString:len()
	wmeConfig.exportText:SetSelection(0, length)
end

function WarnMeConfig.ExportEventsSelectedCallback(wmeConfig, totalEvents, totalWarnings, eventNames, checkList)
	if not checkList then
		wmeConfig.windowFrame:SetVisible(true)
		return
	end
	
	local warnmedata = {}
	warnmedata.events = {}
	warnmedata.warnings = {}
	
	local hasExport = false
	for i = 1, #eventNames do
		if checkList[i] == true then
			hasExport = true
			local event = totalEvents[eventNames[i]]
			warnmedata.events[eventNames[i]] = event
			
			local warning = totalWarnings[event.warningName]
			warnmedata.warnings[event.warningName] = warning
			if warning.warningType == WarnMe.warningTypeTimer then
				warnmedata.warnings[warning.warningName] = totalWarnings[warning.warningName]
			elseif warning.warningType == WarnMe.warningTypeComposite then
				for _, warningName in ipairs(warning.warningNames) do
					local embeddedWarning = totalWarnings[warningName]
					if embeddedWarning.warningType == WarnMe.warningTypeTimer then
						warnmedata.warnings[embeddedWarning.warningName] = totalWarnings[embeddedWarning.warningName]
					end
					
					warnmedata.warnings[warningName] = embeddedWarning
				end
			end
		end
	end

	if hasExport == true then
		local textString = " " .. Utility.Serialize.Inline(warnmedata)
		WarnMeConfig.ShowExportWindow(wmeConfig, textString)
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.ExportEvents(wmeConfig, totalEvents, totalWarnings)
	local eventNames = {}
	for name, event in pairs(totalEvents) do
		if totalWarnings[event.warningName] then
			table.insert(eventNames, name)
		else
			print("Ignoring event " .. event.name .. " as its warning does not exist")
		end
	end
	
	table.sort(eventNames)
	local txtSelector = TextPicker.Create(WarnMe.parentFrame, true)
	wmeConfig.windowFrame:SetVisible(false)
	TextPicker.Show(txtSelector, "Select Events to export", eventNames, function(a, checkList) WarnMeConfig.ExportEventsSelectedCallback(wmeConfig, totalEvents, totalWarnings, eventNames, checkList) end)
end

function WarnMeConfig.ChooseCustomWarnings(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	CustomWarningConfig.Show(wmeConfig.custWarnConfig)
end

function WarnMeConfig.WarningMoveConfirm(wmeConfig, totalWarnings, movedWarnings, ok)
	if ok == true then
		for name, warningPosition in pairs(movedWarnings) do
			print(string.format("Moved warning %s to x=%.02f%%, y=%.02f%%", name, warningPosition.xPct, warningPosition.yPct))
			local warning = totalWarnings[name]
			if warning.warningType == WarnMe.warningTypeTimer then
				warning.slider.xPct = warningPosition.xPct
				warning.slider.yPct = warningPosition.yPct
			else
				warning.xPct = warningPosition.xPct
				warning.yPct = warningPosition.yPct
			end
		end
	end
	
	wmeConfig.windowFrame:SetVisible(true)
end

function WarnMeConfig.WarningPositionCallback(wmeConfig, totalWarnings, warnings, warningPositions)
	local movedWarnings = {}
	local hasMoved = false
	local movedMessage = "Confirm the movement of warnings: "
	for name, warningPosition in pairs(warningPositions) do
		local x, y = warnings[name].getPosition()
		if warningPosition.xPct ~= x or warningPosition.yPct ~= y then
			movedWarnings[name] = { xPct = x, yPct = y }
			if hasMoved == true then
				movedMessage = movedMessage .. ", "
			end
			movedMessage = movedMessage .. name
			hasMoved = true
		end
	end
	
	if hasMoved == true then
		ConfirmationWindow.ShowConfirmationWindow(wmeConfig.cfmWindow, movedMessage, function(a, ok) WarnMeConfig.WarningMoveConfirm(wmeConfig, totalWarnings, movedWarnings, ok) end)
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.PostionWarningsSelectedCallback(wmeConfig, totalWarnings, warningNames, checkList)
	if checkList == nil then
		wmeConfig.windowFrame:SetVisible(true)
		return
	end
	
	local dummyEvent = { name = "dummy" }
	local warnings = {}
	
	local warningPositions = {}
	local xySelector = XYSelector.Create(WarnMe.parentFrame, function(warns) WarnMeConfig.WarningPositionCallback(wmeConfig, totalWarnings, warns, warningPositions) end, true)

	for i = 1, #warningNames do
		if checkList[i] == true then
			WarnMe.CreateEmptyWarning(warnings, totalWarnings, dummyEvent, warningNames[i], xySelector.xyFrame)
		end
	end
	
	WarnMe.InitialiseWarnings(warnings, xySelector.xyFrame)
	
	for name, warning in pairs(warnings) do
		if warning.getPosition == nil or warning.setDragFrameVisible == nil then
			print("Cannot move warning " .. name .. ", ignoring")
		else
			local x, y = warning.getPosition()
			warningPositions[name] = { xPct = x, yPct = y }
		end
	end
	
	XYSelector.SetWarnings(xySelector, warnings)
	XYSelector.SetVisible(xySelector, true)
end

function WarnMeConfig.MoveWarnings(wmeConfig, totalWarnings)
	local warningNames = {}
	for name, warningSpec in pairs(totalWarnings) do
		table.insert(warningNames, name)
	end
	
	table.sort(warningNames)
	local txtSelector = TextPicker.Create(WarnMe.parentFrame, true)
	wmeConfig.windowFrame:SetVisible(false)
	TextPicker.Show(txtSelector, "Select Warnings to Move", warningNames, function(a, checkList) WarnMeConfig.PostionWarningsSelectedCallback(wmeConfig, totalWarnings, warningNames, checkList) end)
end


function WarnMeConfig.ChooseWarning(wmeConfig, warningType, callback)
	local textList = {}
	for name, warning in pairs(WarnMe.totalWarnings) do
		if warning.warningType == warningType or warningType == WarnMe.warningTypeAll then
			table.insert(textList, name)
		end
	end
	
	table.sort(textList)
	
	wmeConfig.windowFrame:SetVisible(false)
	TextPicker.Show(wmeConfig.txtPicker, "Choose Warning", textList, callback)
end

function WarnMeConfig.SetWarningCallback(wmeConfig, warning)
	wmeConfig.windowFrame:SetVisible(true)
	if warning then
		WarnMe.totalWarnings[warning.name] = warning
	end
end

function WarnMeConfig.DeleteWarningCallback(wmeConfig, warningName)
	wmeConfig.windowFrame:SetVisible(true)
	if warningName then
		WarnMe.totalWarnings[warningName] = nil
	end
end

function WarnMeConfig.AddTextWarning(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	TextWarningConfig.Show(wmeConfig.txtWarning, TextWarningConfig.GetDefaultWarning())
end

function WarnMeConfig.EditTextWarning(wmeConfig, warningName)
	if warningName then
		TextWarningConfig.Show(wmeConfig.txtWarning, WarnMe.totalWarnings[warningName])
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.AddTextureWarning(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	TextureWarningConfig.Show(wmeConfig.txtrWarning, TextureWarningConfig.GetDefaultWarning())
end

function WarnMeConfig.EditTextureWarning(wmeConfig, warningName)
	if warningName then
		TextureWarningConfig.Show(wmeConfig.txtrWarning, WarnMe.totalWarnings[warningName])
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.AddTimerWarning(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	TimerWarningConfig.Show(wmeConfig.timerWarning, TimerWarningConfig.GetDefaultWarning())
end

function WarnMeConfig.EditTimerWarning(wmeConfig, warningName)
	if warningName then
		TimerWarningConfig.Show(wmeConfig.timerWarning, WarnMe.totalWarnings[warningName])
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.AddScreenFlashWarning(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	ScreenFlashWarningConfig.Show(wmeConfig.scrnFlashWarning, ScreenFlashWarningConfig.GetDefaultWarning())
end

function WarnMeConfig.EditScreenFlashWarning(wmeConfig, warningName)
	if warningName then
		ScreenFlashWarningConfig.Show(wmeConfig.scrnFlashWarning, WarnMe.totalWarnings[warningName])
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.ChooseEvent(wmeConfig, eventType, callback)
	local textList = {}
	for name, event in pairs(WarnMe.totalEvents) do
		if event.eventType == eventType then
			table.insert(textList, name)
		end
	end
	
	table.sort(textList)
	
	wmeConfig.windowFrame:SetVisible(false)
	TextPicker.Show(wmeConfig.txtPicker, "Choose Event", textList, callback)
end

function WarnMeConfig.SetEventCallback(wmeConfig, event)
	wmeConfig.windowFrame:SetVisible(true)
	if event then
		WarnMe.totalEvents[event.name] = event
	end
end

function WarnMeConfig.DeleteEventCallback(wmeConfig, eventName)
	wmeConfig.windowFrame:SetVisible(true)
	if eventName then
		WarnMe.totalEvents[eventName] = nil
	end
end

function WarnMeConfig.AddEmoteEvent(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	EmoteEventConfig.Show(wmeConfig.evtEmoteConfig, EmoteEventConfig.GetDefaultEvent())
end

function WarnMeConfig.EditEmoteEvent(wmeConfig, eventName)
	if eventName then
		EmoteEventConfig.Show(wmeConfig.evtEmoteConfig, WarnMe.totalEvents[eventName])
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.AddNpcChatEvent(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	NpcChatEventConfig.Show(wmeConfig.evtNpcChatConfig, NpcChatEventConfig.GetDefaultEvent())
end

function WarnMeConfig.EditNpcChatEvent(wmeConfig, eventName)
	if eventName then
		NpcChatEventConfig.Show(wmeConfig.evtNpcChatConfig, WarnMe.totalEvents[eventName])
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.ChooseBuffEvent(wmeConfig, callback)
	local textList = {}
	for name, event in pairs(WarnMe.totalEvents) do
		if event.eventType == WarnMe.eventTypeBuffExists or
		   event.eventType == WarnMe.eventTypeBuffNotExists or
		   event.eventType == WarnMe.eventTypeBuffStackGreater or
		   event.eventType == WarnMe.eventTypeBuffStackLess then
			table.insert(textList, name)
		end
	end
	
	table.sort(textList)
	
	wmeConfig.windowFrame:SetVisible(false)
	TextPicker.Show(wmeConfig.txtPicker, "Choose Event", textList, callback)
end

function WarnMeConfig.AddBuffEvent(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	BuffEventConfig.Show(wmeConfig.evtBuffConfig, BuffEventConfig.GetDefaultEvent())
end

function WarnMeConfig.EditBuffEvent(wmeConfig, eventName)
	if eventName then
		BuffEventConfig.Show(wmeConfig.evtBuffConfig, WarnMe.totalEvents[eventName])
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.AddCastbarEvent(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	CastbarEventConfig.Show(wmeConfig.evtCastbarConfig, CastbarEventConfig.GetDefaultEvent())
end

function WarnMeConfig.EditCastbarEvent(wmeConfig, eventName)
	if eventName then
		CastbarEventConfig.Show(wmeConfig.evtCastbarConfig, WarnMe.totalEvents[eventName])
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.AddStatEvent(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	StatEventConfig.Show(wmeConfig.evtStatConfig, StatEventConfig.GetDefaultEvent())
end

function WarnMeConfig.EditStatEvent(wmeConfig, eventName)
	if eventName then
		StatEventConfig.Show(wmeConfig.evtStatConfig, WarnMe.totalEvents[eventName])
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

function WarnMeConfig.AddAbilityEvent(wmeConfig)
	wmeConfig.windowFrame:SetVisible(false)
	AbilityEventConfig.Show(wmeConfig.evtAbilityConfig, AbilityEventConfig.GetDefaultEvent())
end

function WarnMeConfig.EditAbilityEvent(wmeConfig, eventName)
	if eventName then
		AbilityEventConfig.Show(wmeConfig.evtAbilityConfig, WarnMe.totalEvents[eventName])
	else
		wmeConfig.windowFrame:SetVisible(true)
	end
end

